#include "pekon.h"

void fatRead(int *fat, unsigned char *img)
{
	int i, j = 0;
	for (i = 0; i < 2880; i += 2) {
		fat[i] = (img[j] | img[j + 1] << 8) & 0x0fff;
		fat[i + 1] = (img[j + 1] >> 4 | img[j + 2] << 4) & 0x0fff;
		j += 3;
	}
	return;
}

void fileLoad(struct file *file, int *fat, char *buf, int size)
{
	char *img = (char *) (DISKADDR + 0x003e00);
	int cno = file->cno, i;
	for (;;) {
		if (size <= 512) {
			for (i = 0; i < size; i++) {
				buf[i] = img[cno * 512 + i];
			}
			break;
		}
		for (i = 0; i < 512; i++) {
			buf[i] = img[cno * 512 + i];
		}
		size -= 512;
		buf += 512;
		cno = fat[cno];
	}
	return;
}
