#include "pekon.h"
#include <stdio.h>
#include <string.h>

void HariMain(void)
{
	extern struct tasks *tasks;
	static char ktbl[0x80] = {
		  0,   0, '1',  '2', '3', '4', '5', '6', '7', '8', '9', '0', '-',  '^',   0,   0,
		'Q', 'W', 'E',  'R', 'T', 'Y', 'U', 'I', 'O', 'P', '@', '[',   0,    0, 'A', 'S',
		'D', 'F', 'G',  'H', 'J', 'K', 'L', ';', ':',   0,   0, ']', 'Z',  'X', 'C', 'V',
		'B', 'N', 'M',  ',', '.', '/',   0, '*',   0, ' ',   0,   0,   0,    0,   0,   0,
		  0,   0,   0,    0,   0,   0,   0, '7', '8', '9', '-', '4', '5',  '6', '+', '1',
		'2', '3', '0',  '.',   0,   0,   0,   0,   0,   0,   0,   0,   0,    0,   0,   0,
		  0,   0,   0,    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,    0,   0,   0,
		  0,   0,   0, 0x5c,   0,   0,   0,   0,   0,   0,   0,   0,   0, 0x5c,   0,   0
	};
	static char ktbl2[0x80] = {
		  0,   0, '!', 0x22, '#', '$', '%', '&', 0x27, '(', ')', '~', '=',  '~',   0,   0,
		'Q', 'W', 'E',  'R', 'T', 'Y', 'U', 'I',  'O', 'P', '`', '{',   0,    0, 'A', 'S',
		'D', 'F', 'G',  'H', 'J', 'K', 'L', '+',  '*',   0,   0, '}', 'Z',  'X', 'C', 'V',
		'B', 'N', 'M',  '<', '>', '?',   0, '*',    0, ' ',   0,   0,   0,    0,   0,   0,
		  0,   0,   0,    0,   0,   0,   0, '7',  '8', '9', '-', '4', '5',  '6', '+', '1',
		'2', '3', '0',  '.',   0,   0,   0,   0,    0,   0,   0,   0,   0,    0,   0,   0,
		  0,   0,   0,    0,   0,   0,   0,   0,    0,   0,   0,   0,   0,    0,   0,   0,
		  0,   0,   0,  '_',   0,   0,   0,   0,    0,   0,   0,   0,   0,  '|',   0,   0
	};
	struct fifo fifo, fkey;
	struct mouse mouse;
	struct memory *mem = (struct memory *) 0x003c0000;
	unsigned int memsize;
	struct task *taskA, *taskB, *task;
	struct sheet *shtBack, *shtMouse, *shtWin, *shtWin2;
	struct timer *timer, *timer2, *timer3;
	unsigned char *bufBack, bufMouse[176], *bufWin, *bufWin2, t[8];
	int *fat, fifobuf[64], fkeybuf[32], mx, my, eip, i;
	int keyto = 0, keysf = 0, keyleds = 0, keycmd = -1;
	char s[41];
	gdtidtInit();
	picInit();
	sti();
	fifoInit(&fifo, fifobuf, 64, 0);
	fifoInit(&fkey, fkeybuf, 32, 0);
	keyInit(&fifo);
	mouseEnable(&mouse);
	memsize = memTest(0x00400000, 0xbfffffff);
	memInit(mem);
	memFree(mem, 0x00001000, 0x0009e000);
	memFree(mem, 0x00400000, memsize - 0x00400000);
	timersInit(mem);
	out8(0x0021, 0xf8);		/* 11111000 Timer, PIC1, Keyboard */
	out8(0x00a1, 0xef);		/* 11101111 Mouse */

	taskA = taskInit(mem);
	fifo.task = taskA;
	fkey.task = taskA;
	*((int *) 0x0fec) = (int) &fifo;

	fat = (int *) memAlloc(mem, 4 * 2880);
	fatRead(fat, (unsigned char *) (DISKADDR + 0x000200));

	paletteInit();
	shtInit(mem);
	shtBack = shtAlloc();
	bufBack = (unsigned char *) memAlloc(mem, 320 * 200);
	shtSet(shtBack, bufBack, 320, 200, -1);
	boxfill(shtBack, _FFFFFF, 0, 0, 319, 20);
	boxfill(shtBack, _000000, 0, 21, 319, 21);
	boxfill(shtBack, _848484, 0, 22, 319, 199);
	*((int *) 0x0fe8) = (int) shtBack;

	shtMouse = shtAlloc();
	shtSet(shtMouse, bufMouse, 11, 16, 99);
	mx = (320 - 11) / 2;
	my = (200 - 16) / 2;
	mouseCursor(shtMouse);

	shtWin = shtAlloc();
	bufWin = (unsigned char *) memAlloc(mem, (4 + 22 + 8 * 12) * (22 + 18 * 7));
	shtSet(shtWin, bufWin, 4 + 22 + 8 * 12, 22 + 18 * 7, -1);
	pekontest(shtWin, 1);

	shtWin2 = shtAlloc();
	bufWin2 = (unsigned char *) memAlloc(mem, 132 * 40);
	shtSet(shtWin2, bufWin2, 132, 40, -1);
	winMake(shtWin2, "window", 0);
	taskB = taskAlloc();
	taskB->stack = memAlloc(mem, 64 * 1024);
	taskB->tss.esp = taskB->stack + 64 * 1024 - 8;
	taskB->tss.eip = (int) &taskBMain;
	taskB->tss.es = 1 * 8;
	taskB->tss.cs = 2 * 8;
	taskB->tss.ss = 1 * 8;
	taskB->tss.ds = 1 * 8;
	taskB->tss.fs = 1 * 8;
	taskB->tss.gs = 1 * 8;
	*((int *) (taskB->tss.esp + 4)) = (int) shtWin2;
	taskRun(taskB, 2, 2);

	shtSlide( shtBack,  0,  0);
	shtSlide(shtMouse, mx, my);
	shtSlide(  shtWin,  8, 32);
	shtSlide( shtWin2, 132, 32);
	shtUpdown( shtBack, 0);
	shtUpdown( shtWin2, 1);
	shtUpdown(  shtWin, 2);
	shtUpdown(shtMouse, 3);

	timer = timerAlloc();
	timerInit(timer, &fifo, 0x20);
	timer2 = timerAlloc();
	timerInit(timer2, &fifo, 0x21);
	timerSet(timer2, 300);
	timer3 = timerAlloc();
	timerInit(timer3, &fifo, 0x22);
	fifoPut(&fifo, 0x20);

	fifoPut(&fkey, 0xed);
	fifoPut(&fkey, keyleds);

	for (;;) {
		cli();
		if (fifoStat(&fkey) > 0 && keycmd < 0) {
			keycmd = fifoGet(&fkey);
			kbdReady();
			out8(0x0060, keycmd);
		}
		if (fifoStat(&fifo) == 0) {
			taskSleep(taskA);
			sti();
		} else {
			i = fifoGet(&fifo);
			sti();
			if (i == 0x0c) {
				task = (struct task *) fifoGet(&fifo);
				eip = fifoGet(&fifo);
				sprintf(s, "%s INT 0C EIP=%08X", task->name, eip);
				shtPuts(shtBack, _FFFFFF, _000000, 2, 2, s);
				timerSet(timer3, 500);
			} else if (i == 0x0d) {
				task = (struct task *) fifoGet(&fifo);
				eip = fifoGet(&fifo);
				sprintf(s, "%s INT 0D EIP=%08X", task->name, eip);
				shtPuts(shtBack, _FFFFFF, _000000, 2, 2, s);
				timerSet(timer3, 500);
			} else if (i == 0x20) {
				rtcRead(t);
				sprintf(s, "%02X:%02X", t[2], t[1]);
				shtPuts(shtBack, _FFFFFF, _000000, 310 - 8 * 5, 2, s);
				timerSet(timer, 100);
			} else if (i == 0x21) {
				pekonReload(shtWin);
				timerSet(timer2, 300);
			} else if (i == 0x22) {
				boxfill(shtBack, _FFFFFF, 2, 2, 310 - 8 * 5 - 1, 20);
				shtRefresh(shtBack, 2, 2, 310 - 8 * 5, 20);
			} else if (256 <= i && i <= 511) {
				i -= 256;
				if (i < 0x80) {
					if (keysf == 0) {
						s[0] = ktbl[i];
					} else {
						s[0] = ktbl2[i];
					}
				} else {
					s[0] = 0;
				}
				if ('A' <= s[0] && s[0] <= 'Z') {
					if (((keyleds & 4) == 0 && keysf == 0) || ((keyleds & 4) != 0 && keysf != 0)) {
						s[0] += 0x20;
					}
				}
				if (s[0] != 0) {
					if (keyto == 0) {
						if ('1' <= s[0] && s[0] <= '7') {
							pekonRun(s[0] - '1', fat);
						}
					} else {
						fifoPut(&taskB->fifo, s[0] + 256);
					}
				}
				if (i == 0x0e) {
					if (keyto != 0) {
						fifoPut(&taskB->fifo, 0x08 + 256);
					}
				} else if (i == 0x0f) {
					if (keyto == 0) {
						wtitleMake(shtWin, "pekon", 0);
						wtitleMake(shtWin2, "window", 1);
						keyto = 1;
						fifoPut(&taskB->fifo, 3);
					} else {
						wtitleMake(shtWin, "pekon", 1);
						wtitleMake(shtWin2, "window", 0);
						keyto = 0;
						fifoPut(&taskB->fifo, 4);
					}
					shtRefresh(shtWin, 1, 1, shtWin->sizex - 1, 20);
					shtRefresh(shtWin2, 1, 1, shtWin2->sizex - 1, 20);
				} else if (i == 0x2a) {
					keysf |= 1;
				} else if (i == 0x36) {
					keysf |= 2;
				} else if (i == 0x3a) {
					keyleds ^= 0x04;
					fifoPut(&fkey, 0xed);
					fifoPut(&fkey, keyleds);
				} else if (i == 0x45) {
					keyleds ^= 0x02;
					fifoPut(&fkey, 0xed);
					fifoPut(&fkey, keyleds);
				} else if (i == 0x46) {
					keyleds ^= 0x01;
					fifoPut(&fkey, 0xed);
					fifoPut(&fkey, keyleds);
				} else if (i == 0xaa) {
					keysf &= ~1;
				} else if (i == 0xb6) {
					keysf &= ~2;
				} else if (i == 0xfa) {
					keycmd = -1;
				} else if (i == 0xfe) {
					kbdReady();
					out8(0x0060, keycmd);
				}
			} else if (512 <= i && i <= 767) {
				if (mouseDecode(&mouse, i - 512) != 0) {
					mx += mouse.x;
					my += mouse.y;
					if (mx < 0) {
						mx = 0;
					} else if (mx > 320 - 1) {
						mx = 320 - 1;
					}
					if (my < 0) {
						my = 0;
					} else if (my > 200 - 1) {
						my = 200 - 1;
					}
					shtSlide(shtMouse, mx, my);
					if ((mouse.btn & 0x01) != 0) {
						shtSlide(shtWin, mx - (4 + 22 + 8 * 12) / 2, my - 10);
					}
				}
			} else if (768 <= i && i <= 895) {
				pekonExit(tasks->task + (i - 768));
			}
		}
	}
}

void rtcRead(unsigned char *t)
{
	static unsigned char adr[7] = { 0x00, 0x02, 0x04, 0x07, 0x08, 0x09, 0x32 };
	static unsigned char max[7] = { 0x60, 0x59, 0x23, 0x31, 0x12, 0x99, 0x99 };
	char err;
	int i;
	for (;;) {
		err = 0;
		for (i = 0; i < 7; i++) {
			out8(0x70, adr[i]);
			t[i] = in8(0x71);
		}
		for (i = 0; i < 7; i++) {
			out8(0x70, adr[i]);
			if (t[i] != in8(0x71) || (t[i] & 0x0f) > 9 || t[i] > max[i]) {
				err = 1;
			}
		}
		if (err == 0) {
			return;
		}
	}
}

#define BARSIZE(X, Y)		(18 * 7 - 1) * (X * 100) / Y / 100

void pekontest(struct sheet *sht, int act)
{
	struct file *file = (struct file *) (DISKADDR + 0x002600);
	int i, j = 0, k = 0;
	for (i = 0; i < 224; i++) {
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				j++;
			}
		}
	}
	if (j < 7) {
		k = j;
	} else {
		k = 7;
	}
	winMake(sht, "pekon02", act);
	boxfill(sht, _000000, 4 + 8 * 12, 20, 4 + 8 * 12, 22 + 18 * 7 - 1);
	boxframe(sht, _000000, 5 + 8 * 12, 21, 4 + 22 + 8 * 12 - 2, 21 + BARSIZE(k, j));
	pekonReload(sht);
	return;
}

void pekonPut(struct sheet *sht, int no, char *s)
{
	int y = 22 + 18 * no;
	putfonts(sht, _000000, 2, y, s);
	return;
}

void pekonReload(struct sheet *sht)
{
	struct file *file = (struct file *) (DISKADDR + 0x002600);
	int i, j, k = 0;
	char s[12];
	boxfill(sht, _FFFFFF, 2, 22, 2 + 8 * 12, 22 + 18 * 7 - 2);
	for (i = 0; i < 224; i++) {
		if (k > 7) {
			break;
		}
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				for (j = 0; j < 8; j++) {
					s[j] = file[i].name[j];
				}
				s[ 8] = '.';
				s[ 9] = file[i].ext[0];
				s[10] = file[i].ext[1];
				s[11] = file[i].ext[2];
				s[12] = 0;
				pekonPut(sht, k, s);
				k++;
			}
		}
	}
	shtRefresh(sht, 2, 22, 1 + 8 * 12, 22 + 18 * 7 - 1);
	return;
}

void pekonRun(int no, int *fat)
{
	struct memory *mem = (struct memory *) 0x003c0000;
	struct file *file = (struct file *) (DISKADDR + 0x002600);
	struct task *task;
	int i, j = 0;
	for (i = 0; i < 224; i++) {
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				if (no == j) {
					break;
				}
				j++;
			}
		}
	}
	if (j < 224) {
		task = taskAlloc();
		task->stack = memAlloc(mem, 64 * 1024);
		task->tss.esp = task->stack + 64 * 1024 - 12;
		task->tss.eip = (int) &pekonExec;
		task->tss.es = 1 * 8;
		task->tss.cs = 2 * 8;
		task->tss.ss = 1 * 8;
		task->tss.ds = 1 * 8;
		task->tss.fs = 1 * 8;
		task->tss.gs = 1 * 8;
		*((int *) (task->tss.esp + 4)) = (int) &file[i];
		*((int *) (task->tss.esp + 8)) = (int) fat;
		for (i = 0; i < 8; i++) {
			task->name[i] = file[j].name[i];
		}
		task->name[ 8] = '.';
		task->name[ 9] = file[j].ext[0];
		task->name[10] = file[j].ext[1];
		task->name[11] = file[j].ext[2];
		task->name[12] = 0;
		taskRun(task, 2, 2);
	}
	return;
}

void pekonExec(struct file *file, int *fat)
{
	extern struct tasks *tasks;
	struct task *task = taskNow();
	struct memory *mem = (struct memory *) 0x003c0000;
	struct segdesc *gdt = (struct segdesc *) 0x00270000;
	struct fifo *fifo = (struct fifo *) *((int *) 0x0fec);
	char *p, *q;
	int ssize, dsize, esp, dhrb, i;
	p = (char *) memAlloc(mem, file->size);
	fileLoad(file, fat, p, file->size);
	if (file->size >= 36 && strncmp(p + 4, "Hari", 4) == 0 && *p == 0) {
		ssize = *((int *) (p + 0x00));
		esp = *((int *) (p + 0x0c));
		dsize = *((int *) (p + 0x10));
		dhrb = *((int *) (p + 0x14));
		q = (char *) memAlloc(mem, ssize);
		*((int *) 0x0fe4) = (int) q;
		segdescSet(gdt + 1003, file->size - 1, (int) p, SEGRX + 0x60);
		segdescSet(gdt + 1004, ssize - 1, (int) q, SEGRW + 0x60);
		for (i = 0; i < dsize; i++) {
			q[esp + i] = p[dhrb + i];
		}
		appStart(0x1b, 1003 * 8, esp, 1004 * 8, &(task->tss.esp0));
		memFree(mem, (int) q, ssize);
	}
	cli();
	fifoPut(fifo, task - tasks->task + 768);
	sti();
	for (;;) {
		taskSleep(task);
	}
}

void pekonExit(struct task *task)
{
	struct memory *mem = (struct memory *) 0x003c0000;
	taskSleep(task);
	memFree(mem, task->stack, 64 * 1024);
	task->flag = 0;
	return;
}

int *api(int edi, int esi, int ebp, int esp, int ebx, int edx, int ecx, int eax)
{
	struct task *task = taskNow();
	struct sheet *sht = (struct sheet *) *((int *) 0x0fe8);
	int ds = *((int *) 0x0fe4), *reg = &eax + 1;
	if (edx == 0) {
		return &(task->tss.esp0);
	} else if (edx == 1) {
		sht = shtAlloc();
		shtSet(sht, (char *) ds + ebx, esi, edi, eax);
		winMake(sht, (char *) ds + ecx, 0);
		shtSlide(sht, 100, 50);
		shtUpdown(sht, 3);
		reg[7] = (int) sht;
	}
	return 0;
}

void taskBMain(struct sheet *sht)
{
	struct task *task = taskNow();
	struct timer *timer;
	int fifobuf[32], i, cx = 2, cc = -1;
	char s[2];
	fifoInit(&task->fifo, fifobuf, 32, task);
	timer = timerAlloc();
	timerInit(timer, &task->fifo, 1);
	timerSet(timer, 50);

	for (;;) {
		cli();
		if (fifoStat(&task->fifo) == 0) {
			taskSleep(task);
			sti();
		} else {
			i = fifoGet(&task->fifo);
			sti();
			if (i <= 2) {
				if (i == 1) {
					timerInit(timer, &task->fifo, 2);
					if (cc >= 0) {
						cc = _000000;
					}
				} else {
					timerInit(timer, &task->fifo, 1);
					if (cc >= 0) {
						cc = _FFFFFF;
					}
				}
				timerSet(timer, 50);
			} else if (i == 3) {
				cc = _000000;
			} else if (i == 4) {
				cc = -1;
				boxfill(sht, _FFFFFF, cx, 22, cx + 7, 37);
			} else if (256 <= i && i <= 511) {
				i -= 256;
				if (i == 0x08) {
					if (cx > 2) {
						shtPuts(sht, _FFFFFF, _000000, cx, 22, " ");
						cx -= 8;
					}
				} else {
					if (cx < 122) {
						s[0] = i;
						s[1] = 0;
						shtPuts(sht, _FFFFFF, _000000, cx, 22, s);
						cx += 8;
					}
				}
			}
			if (cc >= 0) {
				boxfill(sht, cc, cx, 22, cx + 7, 37);
			}
			shtRefresh(sht, cx, 22, cx + 8, 38);
		}
	}
}
